/*
 ========================================================================
 Name        : MagicWandServerContainer.cpp
 Author      : Manuela Vogler
 Copyright   : 
 Description : 
 ========================================================================
 */
// [[[ begin generated region: do not modify [Generated System Includes]
#include <barsread.h>
#include <stringloader.h>
#include <eiklabel.h>
#include <eikenv.h>
#include <aknviewappui.h>
#include <eikappui.h>
#include <MagicWandServer.rsg>
// ]]] end generated region [Generated System Includes]

// [[[ begin generated region: do not modify [Generated User Includes]
#include "MagicWandServerContainer.h"
#include "MagicWandServerContainerView.h"
#include "MagicWandServer.hrh"
#include "MagicWandServerContainer.hrh"
// ]]] end generated region [Generated User Includes]

// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]

/**
 * @brief Constructor for performing 1st stage construction.
 */
CMagicWandServerContainer::CMagicWandServerContainer()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	iLabelStatus = NULL;
	// ]]] end generated region [Generated Contents]

	}
/** 
 * @brief Destructor. Destroys child controls.
 */
CMagicWandServerContainer::~CMagicWandServerContainer()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	delete iLabelStatus;
	iLabelStatus = NULL;
	// ]]] end generated region [Generated Contents]

	}

/**
 * @brief Constructs the control (first phase).
 *  Creates an instance and initializes it.
 *  Instance is not left on cleanup stack.
 * @param aRect Bounding rectangle
 * @param aParent Owning parent, or NULL
 * @param aCommandObserver Command observer
 * @return Initialized instance of CMagicWandServerContainer
 */
CMagicWandServerContainer* CMagicWandServerContainer::NewL(const TRect& aRect,
		const CCoeControl* aParent, MEikCommandObserver* aCommandObserver)
	{
	CMagicWandServerContainer* self = CMagicWandServerContainer::NewLC(aRect,
			aParent, aCommandObserver);
	CleanupStack::Pop(self);
	return self;
	}

/**
 * @brief Constructs the control (first phase).
 *  Creates an instance and initializes it.
 *  Instance is left on cleanup stack.
 * @param aRect The rectangle for this window
 * @param aParent Owning parent, or NULL
 * @param aCommandObserver Command observer
 * @return New instance of CMagicWandServerContainer
 */
CMagicWandServerContainer* CMagicWandServerContainer::NewLC(const TRect& aRect,
		const CCoeControl* aParent, MEikCommandObserver* aCommandObserver)
	{
	CMagicWandServerContainer* self = new (ELeave) CMagicWandServerContainer();
	CleanupStack::PushL(self);
	self->ConstructL(aRect, aParent, aCommandObserver);
	return self;
	}

/**
 * @brief Constructs the control (second phase).
 *  Creates a window to contain the controls and activates it.
 * @param aRect Bounding rectangle
 * @param aCommandObserver Command observer
 * @param aParent Owning parent, or NULL
 */
void CMagicWandServerContainer::ConstructL(const TRect& aRect,
		const CCoeControl* aParent, MEikCommandObserver* aCommandObserver)
	{
	if (aParent == NULL)
		{
		CreateWindowL();
		}
	else
		{
		SetContainerWindowL(*aParent);
		}
	iFocusControl = NULL;
	iCommandObserver = aCommandObserver;
	InitializeControlsL();
	SetRect(aRect);
	ActivateL();
	// [[[ begin generated region: do not modify [Post-ActivateL initializations]
	// ]]] end generated region [Post-ActivateL initializations]
	iIsServerStarted = EFalse; //server has not been started yet
	}

/**
 * @brief Returns the number of controls in the container (override).
 * @return Count of controls in the container
 */
TInt CMagicWandServerContainer::CountComponentControls() const
	{
	return (int) ELastControl;
	}

/**
 * @brief Gets the control with the given index (override).
 * @param aIndex Control index [0...n) (limited by #CountComponentControls)
 * @return Pointer to control
 */
CCoeControl* CMagicWandServerContainer::ComponentControl(TInt aIndex) const
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	switch (aIndex)
		{
		case ELabelStatus:
			return iLabelStatus;
		}
	// ]]] end generated region [Generated Contents]

	// handle any user controls here...

	return NULL;
	}

/**
 *	@brief Handle resizing of the container. This implementation will lay out
 *  full-sized controls like list boxes for any screen size, and will layout
 *  labels, editors, etc. to the size they were given in the UI designer.
 */
void CMagicWandServerContainer::SizeChanged()
	{
	CCoeControl::SizeChanged();
	LayoutControls();
	// [[[ begin generated region: do not modify [Generated Contents]

	// ]]] end generated region [Generated Contents]

	}

// [[[ begin generated function: do not modify
/**
 * @brief Layouts components as specified in the UI Designer.
 */
void CMagicWandServerContainer::LayoutControls()
	{
	iLabelStatus->SetExtent(TPoint(2, 9), TSize(238, 168));
	}
// ]]] end generated function

/**
 *	@brief Handles key events.
 *	@param aKeyEvent Key event
 *	@param aType Type of the event
 *	@return EKeyWasConsumed if event was handled, EKeyWasNotConsumed if not
 */
TKeyResponse CMagicWandServerContainer::OfferKeyEventL(
		const TKeyEvent& aKeyEvent, TEventCode aType)
	{
	// [[[ begin generated region: do not modify [Generated Contents]

	// ]]] end generated region [Generated Contents]

	if (iFocusControl != NULL
			&& iFocusControl->OfferKeyEventL(aKeyEvent, aType)
					== EKeyWasConsumed)
		{
		return EKeyWasConsumed;
		}
	return CCoeControl::OfferKeyEventL(aKeyEvent, aType);
	}

// [[[ begin generated function: do not modify
/**
 *	@brief Initializes each control upon creation.
 */
void CMagicWandServerContainer::InitializeControlsL()
	{
	iLabelStatus = new (ELeave) CEikLabel;
	iLabelStatus->SetContainerWindowL(*this);
		{
		TResourceReader reader;
		iEikonEnv->CreateResourceReaderLC(reader,
				R_MAGIC_WAND_SERVER_CONTAINER_LABEL_STATUS);
		iLabelStatus->ConstructFromResourceL(reader);
		CleanupStack::PopAndDestroy(); // reader internal state
		}

	}
// ]]] end generated function

/** 
 * @brief Handles global resource changes, such as scalable UI or skin events (override).
 * @param aType Type of the resource
 */
void CMagicWandServerContainer::HandleResourceChange(TInt aType)
	{
	CCoeControl::HandleResourceChange(aType);
	SetRect(
			iAvkonViewAppUi->View(TUid::Uid(EMagicWandServerContainerViewId))->ClientRect());
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]

	}

/**
 *	@brief Draws container contents.
 *	@param aRect Bounding rectangle
 */
void CMagicWandServerContainer::Draw(const TRect& aRect) const
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	CWindowGc& gc = SystemGc();
	gc.Clear(aRect);

	// ]]] end generated region [Generated Contents]

	}

/**
 * @brief Sets the text of the status label.
 * @param aText Text to be shown
 */
void CMagicWandServerContainer::SetLabelTextL(const TDesC& aText)
	{
	iLabelStatus->SetTextL(aText);
	DrawDeferred();
	}

/**
 * @brief Sets the server's status (started or not).
 * @param aValue ETrue if server has been started, EFalse if not
 */
void CMagicWandServerContainer::SetServerStarted(TBool aValue)
	{
	iIsServerStarted = aValue;
	}

/**
 * @brief Returns the server's status (started or not).
 * @return ETrue is server has been started, EFalse if not
 */
TBool CMagicWandServerContainer::GetServerStarted()
	{
	return iIsServerStarted;
	}
